// Load dts shapes and merge animations
datablock TSShapeConstructor(hydraliskDts)
{
	baseShape  = "./hydralisk.dts";
	sequence0  = "./hyd_root.dsq root";

	sequence1  = "./hyd_move.dsq run";
	sequence2  = "./hyd_move.dsq walk";
	sequence3  = "./hyd_back.dsq back";
	sequence4  = "./hyd_side.dsq side";

	sequence5  = "./hyd_crouch.dsq crouch";
	sequence6  = "./hyd_crouchMove.dsq crouchRun";
	sequence7  = "./hyd_crouch.dsq crouchBack";
	sequence8  = "./hyd_crouchSide.dsq crouchSide";

	sequence9  = "./hyd_root.dsq look";
	sequence10 = "./hyd_root.dsq headside";
	sequence11 = "./hyd_root.dsq headUp";

	sequence12 = "./hyd_fall.dsq jump";
	sequence13 = "./hyd_root.dsq standjump";
	sequence14 = "./hyd_fall.dsq fall";
	sequence15 = "./hyd_root.dsq land";

	sequence16 = "./hyd_root.dsq armAttack";
	sequence17 = "./hyd_root.dsq armReadyLeft";
	sequence18 = "./hyd_root.dsq armReadyRight";
	sequence19 = "./hyd_root.dsq armReadyBoth";
	sequence20 = "./hyd_root.dsq spearready";  
	sequence21 = "./hyd_root.dsq spearThrow";

	sequence22 = "./hyd_root.dsq talk";  

	sequence23 = "./hyd_death.dsq death1"; 
	
	sequence24 = "./hyd_root.dsq shiftUp";
	sequence25 = "./hyd_root.dsq shiftDown";
	sequence26 = "./hyd_acid_attack.dsq shiftAway";
	sequence27 = "./hyd_root.dsq shiftTo";
	sequence28 = "./hyd_root.dsq shiftLeft";
	sequence29 = "./hyd_root.dsq shiftRight";
	sequence30 = "./hyd_root.dsq rotCW";
	sequence31 = "./hyd_root.dsq rotCCW";

	sequence32 = "./hyd_root.dsq undo";
	sequence33 = "./hyd_root.dsq plant";

	sequence34 = "./hyd_sit.dsq sit";

	sequence35 = "./hyd_root.dsq wrench";

   sequence36 = "./hyd_attack.dsq activate";
   sequence37 = "./hyd_attack.dsq activate2";

   sequence38 = "./hyd_root.dsq leftrecoil";
};    

datablock AudioProfile(HydraPainSound)
{
	fileName = "./zhyYes00.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(HydraDeathSound)
{
	fileName = "./zhyDth00.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(HydraJumpSound)
{
	fileName = "./zhyWht01.wav";
	description = AudioClose3d;
	preload = true;
};
datablock PlayerData(HydraliskZombie : PlayerStandardArmor)
{
	shapeFile = "./hydralisk.dts";
	//category = "Vehicles";
	maxDamage = 350;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 0;	//total number of bricks you can carry
	maxWeapons = 0;		//this will be controlled by mini-game code
	maxTools = 0;
	runforce = 100 * 90;
	maxForwardSpeed = 13;
	maxBackwardSpeed = 8;
	maxSideSpeed = 4;
	jumpForce = 8;

	maxForwardCrouchSpeed = 7;
	maxBackwardCrouchSpeed = 5;
	maxSideCrouchSpeed = 5;

	attackpower = 30;
	jumpsound = "HydraJumpSound";
	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;
	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.5708;
	maxlookangle = 1.5708;
	BrickDestroyMaxVolume = 250;
	BrickMaxJumpHeight = 20;
	uiName = "Hydralisk";
	rideable = true;
	canRide = false;
	BrickKillRadius = 2;
//	skinColor = "1 0.79 0.57 1";
//	FollowAnim = "ArmReadyright";
	randomwalk = 1;
	aimatplayer = 0;
	SpecialAttack = 1;
	NoBloodyHands = 1;
	DoNotZombify = 1;
	chance = 40;
	ZombieTeam = "Hydralisk";
	numMountPoints = 0;
	SearchRadius = 50;
//	zDeathSound = "BugDeathSound";
	ignorePipeBombs = 0;
	paintable = true;

	boundingBox			= vectorScale("2.2 2.2 4.2", 4);
	crouchBoundingBox	= vectorScale("2.2 2.2 4", 4);
	proneBoundingBox    = vectorScale("2.2 2.2 4.2", 4);

	useCustomPainEffects = true;
	PainSound			= HydraPainSound;
	DeathSound			= HydraDeathSound;
};
function HydraliskZombie::SpecialAttack(%this,%onshot)

{
	if(getsimtime() >= %this.lastspecial+400 && %this.getstate() !$= "Dead")
	{
//		%ran = getrandom(-1,1);
//		%ran2 = getrandom(-1,1);
//		%this.setmovex(%ran);
//		%this.setmovey(%ran2);
		schedule(500,0,BotShootMode,%this);
//		%this.schedule(2800,clearmovex);
//		%this.schedule(2800,clearmovey);
		%this.lastspecial = getsimtime();
	}
}
function HydraliskZombie::ondisabled(%this,%obj)
{
	parent::ondisabled(%this,%obj);
	ZombieDefault::ondisabled(%this,%obj);
}
function HydraliskZombie::onCollision(%this, %obj, %col, %fade, %pos, %norm)
{
	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
}
function HydraliskZombie::onMount(%a,%player,%vehicle,%d,%e,%f)
{
	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
}
function HydraliskZombie::onUnMount(%a,%player,%vehicle,%d,%e,%f)
{
	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
}
function HydraliskZombie::onAdd(%this,%obj)
{
	parent::onAdd(%this,%obj);
	ZombieDefault::onAdd(%this,%obj);
	%obj.name = "Hydralisk";
//	schedule(15,0,nazify,%obj);
//	%obj.mountimage(bergbiteimage,0);
	%obj.mountimage(HydraAcidImage,0);
}