//Weapon_Hydra_Acid.cs

//audio
datablock AudioProfile(HydraAcidFireSound)
{
	filename    = "./ZHyFir00.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(HydraAcidHitSound)
{
	filename    = "./ZHyHit00.wav";
	description = AudioClose3d;
	preload = true;
};

//muzzle flash effects
datablock ParticleData(HydraAcidFireParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.8 0.1 0.9";
	colors[1]     = "0.0 0.5 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HydraAcidFireEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 1;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.3;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 360;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "HydraAcidFireParticle";

   uiName = "Hydra Acid Flash";
};

//Trail Emitter
datablock ParticleData(HydraAcidTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.9 0.3 0.9";
	colors[1]     = "0.0 0.9 0.0 0.8";
	colors[2]     = "0.0 0.4 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.4;
	sizes[2]      = 0.01;
	times[0]	  = 0;
	times[1]	  = 0.1;
	times[2]	  = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HydraAcidTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 45;
   phiReferenceVel  = 180;
   phiVariance      = 45;
   overrideAdvance = false;
   particles = "HydraAcidTrailParticle";

   uiName = "Hydra Acid Trail";
};

//Explosion Emitter
datablock ParticleData(HydraAcidExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.0 0.9 0.0 0.8";
	colors[1]     = "0.0 0.5 0.6 0.0";
	sizes[0]      = 0.4;
	sizes[1]      = 0.01;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HydraAcidExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 1;
   ejectionOffset   = 0.5;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HydraAcidExplosionParticle";

   useEmitterColors = false;
   uiName = "Hydra Acid Explosion";
};

datablock ExplosionData(HydraAcidExplosion)
{
   //explosionShape = "";
	soundProfile = HydraAcidHitSound;

   lifeTimeMS = 150;

   particleEmitter = HydraAcidExplosionEmitter;
   particleDensity = 6;
   particleRadius = 0.2;

//   emitter[0] = gunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "4.0 5.0 4.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   // Dynamic light
//   lightStartRadius = 0;
//   lightEndRadius = 2;
//   lightStartColor = "0.3 0.6 0.7";
//   lightEndColor = "0 0 0";
};


//Projectile
datablock ProjectileData(HydraAcidProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 45;
//   directDamageType    = $DamageType::HydraAcid;
//   radiusDamageType    = $DamageType::HydraAcid;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 500;
   verticalImpulse	  = 500;
   explosion           = HydraAcidExplosion;
   particleEmitter     = "HydraAcidTrailEmitter";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.5;

//   hasLight    = false;
//   lightRadius = 3.0;
//   lightColor  = "0 0 0.5";

   uiName = "Hydralisk Acid";
};

//////////
// item //
//////////
datablock ItemData(HydraAcidItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile =  "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "";
//	iconName = "./Icon_2guns";
	doColorShift = false;
	colorShiftColor = "0.1 0.1 0.2 1.000";

	 // Dynamic properties defined by the scripts
	image = HydraAcidImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HydraAcidImage)
{
   // Basic Item properties
   shapeFile =  "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = HydraAcidProjectile;
   projectileType = Projectile;

//	casing = ;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = false;
   colorShiftColor = HydraAcidItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
//	stateSequence[0] = "ready";

	stateName[1] = "Ready";
//	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
//	stateEjectShell[2]       = true;
//	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Reload";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.09;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = HydraAcidFireSound;
   stateEmitter[2]					= HydraAcidFireEmitter;
	stateEmitterTime[2]				= 0.06;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
//	stateTransitionOnTriggerUp[4] = "FireLeft";
//	stateSequence[4] = "ready";
	stateTransitionOnTimeOut[3] = "ready";
	stateTimeoutValue[3] = 0.3;

//	stateName[4] = "FireLeft";
//	//stateTimeoutValue[5] = 0.09;
//	stateScript[4] = "onFireAcid";
//	stateTransitionOnTimeOut[3] = "ready";
//	stateTimeoutValue[4] = 0.3;
};


//function HydraAcidImage::onFireAcid(%this,%obj,%slot)
//{
//   %obj.setImageTrigger(1,1);
//}


//datablock ShapeBaseImageData(LeftHydraAcidImage : HydraAcidImage)
//{
   // Basic Item properties
//   shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";
//   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
//*   mountPoint = 1;
//   offset = "0 0 0";
//   eyeOffset = 0; //"0.7 1.2 -0.5";
//   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
//   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
//   className = "WeaponImage";

   // Projectile && Ammo.
//   item = BowItem;
//   ammo = " ";
//   projectile = HydraAcidProjectile;
//   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
//   melee = false;
   //raise your arm up or not
//   armReady = false;

//   doColorShift = false;
//   colorShiftColor = HydraAcidItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
//	stateName[0] = "Activate";
//	stateTransitionOnTimeout[0] = "Ready";
//	stateTimeoutValue[0] = 0.2;
////	stateSequence[0] = "ready";
////   stateSound[0]		= weaponSwitchSound;

//	stateName[1] = "Ready";
////	stateSequence[1] = "ready";
//	stateTransitionOnTriggerDown[1] = "Fire";

//	stateName[2] = "Fire";
////	stateEjectShell[2]       = true;
////	stateSequence[2] = "Fire";
//	stateTransitionOnTimeout[2] = "Reload";
 //  stateWaitForTimeout[2] = true;
//	stateTimeoutValue[2] = 0.09;
//	stateFire[2] = true;
//	stateAllowImageChange[2] = false;
//	stateScript[2] = "onFire";
//	stateSound[2] = HydraAcidFireSound;
 //  stateEmitter[2]					= HydraAcidFireEmitter;
//	stateEmitterTime[2]				= 0.06;
//	stateEmitterNode[2]				= "muzzleNode";

//	stateName[3] = "Reload";
//	stateAllowImageChange[3] = false;
//	stateTransitionOnTimeOut[3] = "ready";
//	stateTimeoutValue[3] = 0.3;

//};

//function LeftHydraAcidImage::onFire(%this, %obj, %slot)
//{
//   Parent::onFire(%this,%obj,%slot);
//}

function HydraAcidImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
 //  //mount lefthanded gun
//   %obj.mountImage(LeftHydraAcidImage, 1);
//   //%obj.playThread(0, armreadyboth);
}
function HydraAcidImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded item
//   %obj.unMountImage(1);
 //  //%obj.playThread(0, root);
}


//function LeftHydraAcidImage::onMount(%this, %obj, %slot)
//{
//   Parent::onMount(%this, %obj, %slot);
////   %obj.playThread(1, armreadyboth);
//}
//function LeftHydraAcidImage::onUnMount(%this, %obj, %slot)
//{
//   Parent::onUnMount(%this, %obj, %slot);
//}

function HydraAcidImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	

   //%obj.setImageTrigger(1,1);
}
